#include "ChartObjectHLine.mqh"
#include "ChartObjectLabel.mqh"
#include "..\Pointer.mqh"

class CHARTOBJECTHLINE_TEXT : public CHARTOBJECTHLINE
{
protected:
  CHARTOBJECT* Label;

public:
  CHARTOBJECTHLINE_TEXT(const double dPrice = 0, const string Str = "", const long chart_id = 0, const bool Add = FALSE )
                    : CHARTOBJECTHLINE(dPrice, chart_id, Add)
  {
    this.Label = new CHARTOBJECTLABEL(0, 0, Str, chart_id, 0, &this);

    this.Label.SetProperty(OBJPROP_ANCHOR, ANCHOR_RIGHT_UPPER);
    this.Label.SetProperty(OBJPROP_CORNER, CORNER_RIGHT_UPPER);
  }

  ~CHARTOBJECTHLINE_TEXT( void )
  {
    POINTER::DeleteObject(this.Label);
  }

  virtual void operator =( const string Value ) const
  {
    this.Label.SetProperty(OBJPROP_TEXT, Value);

    return;
  }

  virtual const CHARTOBJECT* GetMe( void ) const
  {
    return(this.Label);
  }
};