#include "ChartObject.mqh"

class CHARTOBJECTLABEL : public CHARTOBJECT
{
private:
  const CHARTOBJECT* Fixer;
  int X, Y;

  bool SetChange( void )
  {
    int iX = this.X;
    int iY = this.Y;

    if (::CheckPointer(this.Fixer) != POINTER_INVALID)
      this.Fixer.GetXY(iX, iY);
    else
      this.GetXY(iX, iY);

    const bool Res = ((iX != this.X) || (iY != this.Y));

    if (Res)
      this.SetCoordinates(iX, iY);

    return(Res);
  }

// -  
  virtual void EventTimer( void )
  {
    if (this.SetChange())
      ::EventChartCustom(this.Chart, (ushort)(this.EventCustom), this.X, 0, "");

    return;
  }

  virtual void Event( const int id, const long &lparam, const double &dparam, const string &sparam )
  {
    if ((id == ::CHARTEVENT_OBJECT_DRAG) || (id == ::CHARTEVENT_OBJECT_CHANGE) ||
       ((::CheckPointer(this.Fixer) != POINTER_INVALID) && ((id == ::CHARTEVENT_CHART_CHANGE) || (id == this.Fixer.GetEventCustom()))))
      this.EventTimer();

    return;
  }

  void SetCoordinates( const int NewX = 0, const int NewY = 0 )
  {
    this.SetProperty(OBJPROP_XDISTANCE, NewX);
    this.SetProperty(OBJPROP_YDISTANCE, NewY);

    this.GetXY(this.X, this.Y);

    return;
  }

protected:

public:
  CHARTOBJECTLABEL(const int iX = 0, const int iY = 0, const string Str = "", const long chart_id = 0, const int sub_window = 0, const CHARTOBJECT* objFixer = NULL, const bool Add = FALSE )
                    : CHARTOBJECT((objFixer == NULL) ? Add : TRUE, chart_id, (string)::MathRand(), ::OBJ_LABEL, sub_window, 0, 0), Fixer(objFixer), X(iX), Y(iY)
  {
    this.SetCoordinates(this.X, this.Y);

    this = Str;
  }

};