#property strict

#include "Indicator.mqh"
#include "..\ChartObjects\ChartObjectTicks.mqh"

class TICKS : public INDICATOR
{
protected:
  const CHARTOBJECT *ChartObject;

public:
  TICKS( const color ColorBid = clrBlue, const color ColorAsk = clrRed, const uchar Transparency = 0xFF )
        : ChartObject(new CHARTOBJECTTICKS(0, ColorBid, ColorAsk, Transparency))
  {
/*
    const string Names[] = {__FUNCTION__};
    const int Types[] = {DRAW_LINE};
    const color Colors[] = {clrRed};

    const int Size = ::ArraySize(Names);

    ::ArrayResize(this.Buffers, Size);

    for (int i = 0; i < Size; i++)
      this.Buffers[i] = new BUFFER(Types[i], EMPTY, EMPTY, Colors[i], Names[i], TRUE, TRUE); //       -   
*/
  }

  ~TICKS( void )
  {
    POINTER::DeleteObject(this.ChartObject);
  }

  virtual int Calculate( const int rates_total,
                         const int prev_calculated,
                         const datetime &time[],
                         const double &open[],
                         const double &high[],
                         const double &low[],
                         const double &close[],
                         const long &tick_volume[],
                         const long &volume[],
                         const int &spread[] )
  {
    if (::ChartGetInteger(0, ::CHART_FIRST_VISIBLE_BAR) <= ::ChartGetInteger(0, ::CHART_VISIBLE_BARS))
      this.ChartObject.Visual();

    return(rates_total);
  }
};